OpenVDB: CheckFogVolume< GridType > Class Template Reference

OpenVDB 5.0.0

Public Types | Public Member Functions | Static Public Member Functions | List of all members
CheckFogVolume< GridType > Class Template Reference

Class that performs various types of checks on fog volumes. More...

`#include <Diagnostics.h>`

## Public Types
using | ValueType = typename GridType::ValueType
using | MaskType = typename GridType::template ValueConverter< bool >::Type

## Public Member Functions
| CheckFogVolume (const GridType &grid)
Index64 | valueCount () const
| Return the number of values (i.e. background, tiles or voxels) that have failed one or more checks. More...
Index64 | failureCount () const
| Return total number of failed checks. More...
const GridType & | grid () const
| Return a const reference to the grid. More...
void | clear ()
| Clear the mask and error counter. More...
std::string | checkClassType () const
| Return a nonempty message if the grid's class is a level set. More...
std::string | checkBackground () const
| Return a nonempty message if the background value is not zero. More...
std::string | checkFinite (bool updateMask=false)
| Return a nonempty message if any of the values are not finite. i.e. NaN or inf. More...
std::string | checkInactiveValues (bool updateMask=false)
| Return a nonempty message if any of the inactive values are not zero. More...
std::string | checkRange (bool updateMask=false)
| Return a nonempty message if the active voxel values are out-of-range, i.e. not in the range [0,1]. More...
std::string | check (size_t n=6, bool updateMask=false)
| Return a nonempty message if an error or issue is detected. Only runs tests with a number lower than or equal to n, where: More...
MaskType::ConstPtr | mask () const
| Return a boolean mask of all the values (i.e. tiles and/or voxels) that have failed one or more checks. More...
MaskType::Ptr | mask ()
| Return a boolean mask of all the values (i.e. tiles and/or voxels) that have failed one or more checks. More...

## Static Public Member Functions
static std::string | checkValueType ()
| Return a nonempty message if the grid's value type is a floating point. More...

## Detailed Description

### template<class GridType>
class openvdb::v5_0::tools::CheckFogVolume< GridType >

Class that performs various types of checks on fog volumes.

Note
  The most common usage is to simply call CheckFogVolume::check()

## Member Typedef Documentation

## ◆ MaskType

using MaskType = typename GridType::template ValueConverter<bool>::Type

## ◆ ValueType

using ValueType = typename GridType::ValueType

## Constructor & Destructor Documentation

## ◆ CheckFogVolume()

CheckFogVolume | ( | const GridType & | grid | ) |
| inline

## Member Function Documentation

## ◆ check()

std::string check | ( | size_t | n = `6`,
|  | bool | updateMask = `false`
| ) |  |
| inline

Return a nonempty message if an error or issue is detected. Only runs tests with a number lower than or equal to n, where:

Fast checks 1: value type is floating point 2: has FOG volume class type 3: background value is zero

Slower checks 4: all the values are finite, i.e not NaN or infinite 5: inactive values are zero 6: active values are in the range [0,1]

## ◆ checkBackground()

std::string checkBackground | ( |  | ) | const
| inline

Return a nonempty message if the background value is not zero.

Note
  Small run-time overhead

## ◆ checkClassType()

std::string checkClassType | ( |  | ) | const
| inline

Return a nonempty message if the grid's class is a level set.

Note
  Small run-time overhead

## ◆ checkFinite()

std::string checkFinite | ( | bool | updateMask = `false` | ) |
| inline

Return a nonempty message if any of the values are not finite. i.e. NaN or inf.

Note
  Medium run-time overhead

## ◆ checkInactiveValues()

std::string checkInactiveValues | ( | bool | updateMask = `false` | ) |
| inline

Return a nonempty message if any of the inactive values are not zero.

Note
  Medium run-time overhead

## ◆ checkRange()

std::string checkRange | ( | bool | updateMask = `false` | ) |
| inline

Return a nonempty message if the active voxel values are out-of-range, i.e. not in the range [0,1].

Note
  Medium run-time overhead

## ◆ checkValueType()

static std::string checkValueType | ( |  | ) |
| inlinestatic

Return a nonempty message if the grid's value type is a floating point.

Note
  No run-time overhead

## ◆ clear()

void clear | ( |  | ) |
| inline

Clear the mask and error counter.

## ◆ failureCount()

Index64 failureCount | ( |  | ) | const
| inline

Return total number of failed checks.

Note
  If only one check was performed and the mask was updated failureCount equals valueCount.

## ◆ grid()

const GridType& grid | ( |  | ) | const
| inline

Return a const reference to the grid.

## ◆ mask() [1/2]

MaskType::ConstPtr mask | ( |  | ) | const
| inline

Return a boolean mask of all the values (i.e. tiles and/or voxels) that have failed one or more checks.

## ◆ mask() [2/2]

MaskType::Ptr mask | ( |  | ) |
| inline

Return a boolean mask of all the values (i.e. tiles and/or voxels) that have failed one or more checks.

## ◆ valueCount()

Index64 valueCount | ( |  | ) | const
| inline

Return the number of values (i.e. background, tiles or voxels) that have failed one or more checks.

The documentation for this class was generated from the following file:

- Diagnostics.h